library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity operazioni is
	port(din: in std_logic_vector(15 downto 0);
	clk, start: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end operazioni;

architecture beh of operazioni is
type stati is (IDLE,LETOP,LETD0,LETD1,ESEGUI);
signal s: stati;
signal enop,end0,end1,enexe: std_logic;
signal d0,d1: std_logic_vector(15 downto 0);
signal op: std_logic_vector(1 downto 0);
signal conta: integer range 0 to 3;
begin
	--cu
	process(clk)
	begin
		if clk'event and clk='0' then
			case s is
				when IDLE => if start='1' then
								s<= LETOP;
							 else s <= IDLE;
							 end if;
				when LETOP => s<= LETD0;
				when LETD0 => if op="00" then -- not
							               s<= ESEGUI;
							   else 		   s<= LETD1;
							  end if;
				when LETD1 => s <= ESEGUI;
				when ESEGUI => case op is
					            when "00" | "01" => --not | or
								                    s<= IDLE;
								when "10" => --add
								             if conta=1 then s<= IDLE;
									 		 else s<= ESEGUI;
											 end if;
								when "11" => --mac
											if conta = 3 then s<= IDLE;
											else s<= ESEGUI;
											end if;
								when others => s<= IDLE;
							   end case;
				when others => s<= IDLE;
			end case;
		end if;	
	 end process;
	 
	 enop<= '1' when s=LETOP else '0';
	 end0<= '1' when s=LETD0 else '0';
	 end1<= '1' when s=LETD1 else '0';
	 enexe<= '1' when s=ESEGUI else '0';
  
    process(clk)
	begin
		if clk'event and clk='0' then
			if enop='1' then op<= din(1 downto 0);
			end if;
			if end0='1' then d0<=din;
				             conta<= 0;
			end if;
			if end1='1' then d1<=din;
			end if;
			if enexe = '1' then
				case op is
					when "00" => -- not
							ris<= not d0;
					when "01" =>  -- or
							ris <= d0 or d1;
					when "10" =>  --add
							if conta=1 then ris<= d0+d1;
							else conta <= conta+1;
							end if;
					when "11" => -- mac
					        if conta=3 then ris<= d0+d1(15 downto 8)*d1(7 downto 0);
							else conta<= conta+1;
							end if;
				    when others => ris <= (others => 'X');
				 end case;
				end if;
		  	
				
			if enexe='1' and (op="00" or op="01" or (op="10" and conta=1) or (op="11" and conta=3)	 )
				then fine <= '1';
				else fine <= '0';
			end if; 
		  
		  end if;
		  
	end process;	 
end beh;
	 
